Subject: Re: SPARSE files considered harmful - please revert
From: "Max Bowsher" <[email-masked]>
To: <[email-masked]>
Cc: <[email-masked]>
Date: Mon, 19 May 2003 00:52:02 +0100

Martin Buchholz wrote:
>>>>>> "Max" == Max Bowsher <[email-masked]> writes:
>
> Max> May I suggest a middle road? Why not let sparse files be configurable
> as a Max> $CYGWIN option? This would allow those users who actually want
> them to Max> enable them with minimal effort, but keep them off for most
> users.
>
> I suspect that SPARSE files are genuinely useful, when storing large
> files that have holes in them.  But I can't imagine one ever wanting
> to use SPARSE for all files, because most files aren't like that.  So
> I don't think sparseness is a good candidate for being put into
> $CYGWIN.

Agreed. I was just trying to find some simple compromise. Have you reviewed
the long conversation that went on in cygwin-patches in February? Based on
the ease with which this patch was accepted, I'm conjecturing that the core
developers won't want a simple reversion.

> We could have a much cleverer implementation of sparseness, if we kept
> statistics on the number and size of zero bytes in a file while it was
> being written.  When we did the close(), we could automatically
> transform it into a sparse file.  But I don't think even that should
> be the default behavior, because it would make all IO slower.

And it wouldn't achieve Vaclav Heisman's original goal, either - he wanted
to avoid the delay caused by Windows zero-filling a file when it was
initially writted to at a large offset.

Max.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/